Subject: Re: bug#6956: 24.0.50; pasting mouse selection in other session pastes only first word

From: Eli Zaretskii <[email-masked]>
Date: Sat, 04 Sep 2010 18:44:30 +0300

> From: "Drew Adams" <[email-masked]>
> Cc: <[email-masked]>, <[email-masked]>
> Date: Sat, 4 Sep 2010 08:06:19 -0700
> 
> FWIW, though I seldom use Emacs on X Window these days, I used it for well a
> over a decade and I do not recall pasting with mouse-2 after selecting multiple
> things (words, lines, whatever) using mouse-1 + mouse-3 (or using any other
> mouse-selection method, for that matter) ever having done anything other than
> paste the entire selection.  Including pasting between Emacs sessions.  I do not
> believe this sane behavior is/was Windows-only.

It still works on X like you remember.  But it works because the
extended selection gets put into the PRIMARY selection, and mouse-2
pastes from there.  See Jan's response to my guess about this.

By contrast, on Windows, the (emulated) primary selection is not
accessible from other applications.

I'm awaiting Stefan or Chong to respond to my suggestions in this
thread.  If the decision is not to change anything on X, I will then
fix it for MS-Windows only, probably subject to a single option which
you will have to customize.

> IMO, when mouse-pasting after mouse-selecting, no one would ever want what is
> pasted to be something different from what s?he had selected.  The meaning of
> "drag" is irrelevant in this regard (though it might be relevant to some
> function names or code comments).

The problem is that on X, there are 2 different kinds of "pasting":
one from the clipboard, the other from PRIMARY.  The current
convention on X is that the mouse pastes from PRIMARY, while C-y
pastes from the clipboard.

"Drag" is relevant because Emacs puts the text you drag across into
the kill ring (when mouse-drag-copy-region is non-nil).  And anything
that goes to the kill ring automatically goes to the clipboard as
well.  By contrast, mouse-2 pastes only from PRIMARY.

And please, stop arguing with the principle.  Emacs operation on X wrt
selections and pasting has changed, and there's nothing you or me can
do about that, except making sure that there are options one can
customize to get the old behavior.  The default behavior on Windows
will need to follow the behavior on X, with some reasonable
compromises due to the fact that there's only the clipboard.  Again,
customizable options should exist to get you the old behavior on
Windows.  All I'm trying to do is get you what you want, and yet each
time I need to argue with you about this -- why?